=== android/CMakeLists.txt ===
if(QT_VERSION_MAJOR LESS 6)
  set(KID3_ANDROID_MIN_SDK_VERSION 16)
  set(KID3_ANDROID_TARGET_SDK_VERSION 22)
  set(KID3_ANDROID_NAME "org.qtproject.qt5.android.bindings.QtApplication")
  set(FIX_KID3ACTIVITY "import fileinput; [print(line, end='') for line in fileinput.input()]")
  set(ANDROIDMANIFEST_XML_IN "AndroidManifest.xml.in")
else()
  set(KID3_ANDROID_MIN_SDK_VERSION 23)
  # To avoid scoped storage with API 29+, we need access to real files.
  # https://developer.android.com/about/versions/10/behavior-changes-10
  set(KID3_ANDROID_TARGET_SDK_VERSION 28)
  set(KID3_ANDROID_NAME "org.qtproject.qt.android.bindings.QtApplication")
  set(FIX_KID3ACTIVITY "import fileinput; \
    [print(line.replace('org.qtproject.qt5', 'org.qtproject.qt'), end='') \
    for line in fileinput.input()]")
  set(ANDROIDMANIFEST_XML_IN "AndroidManifest-qt6.xml.in")
endif()

set(QT_ANDROID_APP_PACKAGE_NAME "net.sourceforge.kid3")
set(QT_ANDROID_APP_NAME "Kid3")
set(_androidPackageDir ${CMAKE_CURRENT_BINARY_DIR}/package)
configure_file(${ANDROIDMANIFEST_XML_IN}
               ${_androidPackageDir}/AndroidManifest.xml @ONLY)
add_custom_command(OUTPUT ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_androidPackageDir}/src/net/sourceforge/kid3
  COMMAND ${PYTHON_EXECUTABLE} -c "${FIX_KID3ACTIVITY}"
          ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Activity.java
          > ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java VERBATIM
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Activity.java
)
set(_widths 32 48 64 128)
set(_densities ldpi mdpi hdpi xhdpi)
set(_icons)
list(LENGTH _widths _len)
math(EXPR _maxnr "${_len} - 1")
foreach(_nr RANGE ${_maxnr})
  list(GET _widths ${_nr} _width)
  list(GET _densities ${_nr} _dens)
  set(_icondir ${_androidPackageDir}/res/drawable-${_dens})
  set(_icon ${_icondir}/icon.png)
  list(APPEND _icons ${_icon})
  set(_png ${CMAKE_CURRENT_SOURCE_DIR}/../src/app/${_width}-apps-kid3.png)
  add_custom_command(OUTPUT ${_icon}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${_icondir}
    COMMAND ${CMAKE_COMMAND} -E copy ${_png} ${_icon}
    DEPENDS ${_png}
  )
endforeach()

add_custom_target(android-package
  DEPENDS ${_icons}
          ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java)
if(CMAKE_BUILD_TYPE STREQUAL "Release" AND ANDROID_KEYSTORE_PATH AND ANDROID_KEYSTORE_ALIAS)
  set(_keystorePathAlias ${ANDROID_KEYSTORE_PATH} ${ANDROID_KEYSTORE_ALIAS})
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
  set(_keystorePathAlias "UNSIGNED_RELEASE")
else()
  set(_keystorePathAlias)
endif()


if(QT_VERSION_MAJOR LESS 6)
  set(_deploymentDepends
      lib/libQt${QT_VERSION_MAJOR}Core.so lib/libQt${QT_VERSION_MAJOR}Xml.so lib/libQt${QT_VERSION_MAJOR}Network.so lib/libQt${QT_VERSION_MAJOR}Gui.so
      plugins/bearer/libqandroidbearer.so plugins/platforms/android/libqtforandroid.so plugins/iconengines/libqsvgicon.so
      plugins/imageformats/libqjpeg.so
      plugins/imageformats/libqsvg.so
      plugins/imageformats/libqwebp.so
      lib/libQt${QT_VERSION_MAJOR}Multimedia.so lib/libQt${QT_VERSION_MAJOR}Qml.so
      lib/libQt${QT_VERSION_MAJOR}Quick.so lib/libQt${QT_VERSION_MAJOR}Widgets.so lib/libQt${QT_VERSION_MAJOR}Svg.so
      lib/libQt${QT_VERSION_MAJOR}QuickControls2.so lib/libQt${QT_VERSION_MAJOR}QuickTemplates2.so lib/libQt${QT_VERSION_MAJOR}AndroidExtras.so
      qml/Qt/labs/folderlistmodel/libqmlfolderlistmodelplugin.so qml/Qt/labs/folderlistmodel/plugins.qmltypes qml/Qt/labs/folderlistmodel/qmldir
      qml/QtQuick/Layouts/libqquicklayoutsplugin.so qml/QtQuick/Layouts/plugins.qmltypes qml/QtQuick/Layouts/qmldir
      qml/QtQuick/Window.2/libwindowplugin.so qml/QtQuick/Window.2/plugins.qmltypes qml/QtQuick/Window.2/qmldir
      qml/QtQuick/Templates.2/libqtquicktemplates2plugin.so qml/QtQuick/Templates.2/plugins.qmltypes qml/QtQuick/Templates.2/qmldir
      qml/QtQuick.2/libqtquick2plugin.so qml/QtQuick.2/plugins.qmltypes qml/QtQuick.2/qmldir
      qml/QtQuick/Controls.2/libqtquickcontrols2plugin.so qml/QtQuick/Controls.2/plugins.qmltypes qml/QtQuick/Controls.2/qmldir
      qml/QtQuick/Controls.2/AbstractButton.qml qml/QtQuick/Controls.2/ApplicationWindow.qml qml/QtQuick/Controls.2/BusyIndicator.qml qml/QtQuick/Controls.2/Button.qml qml/QtQuick/Controls.2/ButtonGroup.qml qml/QtQuick/Controls.2/CheckBox.qml qml/QtQuick/Controls.2/CheckDelegate.qml qml/QtQuick/Controls.2/ComboBox.qml qml/QtQuick/Controls.2/Container.qml qml/QtQuick/Controls.2/Control.qml qml/QtQuick/Controls.2/DelayButton.qml qml/QtQuick/Controls.2/Dial.qml qml/QtQuick/Controls.2/Dialog.qml qml/QtQuick/Controls.2/DialogButtonBox.qml qml/QtQuick/Controls.2/Drawer.qml qml/QtQuick/Controls.2/Frame.qml qml/QtQuick/Controls.2/GroupBox.qml qml/QtQuick/Controls.2/ItemDelegate.qml qml/QtQuick/Controls.2/Label.qml qml/QtQuick/Controls.2/Menu.qml qml/QtQuick/Controls.2/MenuItem.qml qml/QtQuick/Controls.2/MenuSeparator.qml qml/QtQuick/Controls.2/Page.qml qml/QtQuick/Controls.2/PageIndicator.qml qml/QtQuick/Controls.2/Pane.qml qml/QtQuick/Controls.2/Popup.qml qml/QtQuick/Controls.2/ProgressBar.qml qml/QtQuick/Controls.2/RadioButton.qml qml/QtQuick/Controls.2/RadioDelegate.qml qml/QtQuick/Controls.2/RangeSlider.qml qml/QtQuick/Controls.2/RoundButton.qml qml/QtQuick/Controls.2/ScrollBar.qml qml/QtQuick/Controls.2/ScrollIndicator.qml qml/QtQuick/Controls.2/ScrollView.qml qml/QtQuick/Controls.2/Slider.qml qml/QtQuick/Controls.2/SpinBox.qml qml/QtQuick/Controls.2/StackView.qml qml/QtQuick/Controls.2/SwipeDelegate.qml qml/QtQuick/Controls.2/SwipeView.qml qml/QtQuick/Controls.2/Switch.qml qml/QtQuick/Controls.2/SwitchDelegate.qml qml/QtQuick/Controls.2/TabBar.qml qml/QtQuick/Controls.2/TabButton.qml qml/QtQuick/Controls.2/TextArea.qml qml/QtQuick/Controls.2/TextField.qml qml/QtQuick/Controls.2/ToolBar.qml qml/QtQuick/Controls.2/ToolButton.qml qml/QtQuick/Controls.2/ToolSeparator.qml qml/QtQuick/Controls.2/ToolTip.qml qml/QtQuick/Controls.2/Tumbler.qml
      qml/QtQuick/Controls.2/Material/libqtquickcontrols2materialstyleplugin.so qml/QtQuick/Controls.2/Material/plugins.qmltypes qml/QtQuick/Controls.2/Material/qmldir
      qml/QtQuick/Controls.2/Material/ApplicationWindow.qml qml/QtQuick/Controls.2/Material/BoxShadow.qml qml/QtQuick/Controls.2/Material/BusyIndicator.qml qml/QtQuick/Controls.2/Material/Button.qml qml/QtQuick/Controls.2/Material/CheckBox.qml qml/QtQuick/Controls.2/Material/CheckDelegate.qml qml/QtQuick/Controls.2/Material/CheckIndicator.qml qml/QtQuick/Controls.2/Material/ComboBox.qml qml/QtQuick/Controls.2/Material/CursorDelegate.qml qml/QtQuick/Controls.2/Material/DelayButton.qml qml/QtQuick/Controls.2/Material/Dial.qml qml/QtQuick/Controls.2/Material/Dialog.qml qml/QtQuick/Controls.2/Material/DialogButtonBox.qml qml/QtQuick/Controls.2/Material/Drawer.qml qml/QtQuick/Controls.2/Material/ElevationEffect.qml qml/QtQuick/Controls.2/Material/Frame.qml qml/QtQuick/Controls.2/Material/GroupBox.qml qml/QtQuick/Controls.2/Material/ItemDelegate.qml qml/QtQuick/Controls.2/Material/Label.qml qml/QtQuick/Controls.2/Material/Menu.qml qml/QtQuick/Controls.2/Material/MenuItem.qml qml/QtQuick/Controls.2/Material/MenuSeparator.qml qml/QtQuick/Controls.2/Material/Page.qml qml/QtQuick/Controls.2/Material/PageIndicator.qml qml/QtQuick/Controls.2/Material/Pane.qml qml/QtQuick/Controls.2/Material/Popup.qml qml/QtQuick/Controls.2/Material/ProgressBar.qml qml/QtQuick/Controls.2/Material/RadioButton.qml qml/QtQuick/Controls.2/Material/RadioDelegate.qml qml/QtQuick/Controls.2/Material/RadioIndicator.qml qml/QtQuick/Controls.2/Material/RangeSlider.qml qml/QtQuick/Controls.2/Material/RectangularGlow.qml qml/QtQuick/Controls.2/Material/RoundButton.qml qml/QtQuick/Controls.2/Material/ScrollBar.qml qml/QtQuick/Controls.2/Material/ScrollIndicator.qml qml/QtQuick/Controls.2/Material/Slider.qml qml/QtQuick/Controls.2/Material/SliderHandle.qml qml/QtQuick/Controls.2/Material/SpinBox.qml qml/QtQuick/Controls.2/Material/StackView.qml qml/QtQuick/Controls.2/Material/SwipeDelegate.qml qml/QtQuick/Controls.2/Material/SwipeView.qml qml/QtQuick/Controls.2/Material/Switch.qml qml/QtQuick/Controls.2/Material/SwitchDelegate.qml qml/QtQuick/Controls.2/Material/SwitchIndicator.qml qml/QtQuick/Controls.2/Material/TabBar.qml qml/QtQuick/Controls.2/Material/TabButton.qml qml/QtQuick/Controls.2/Material/TextArea.qml qml/QtQuick/Controls.2/Material/TextField.qml qml/QtQuick/Controls.2/Material/ToolBar.qml qml/QtQuick/Controls.2/Material/ToolButton.qml qml/QtQuick/Controls.2/Material/ToolSeparator.qml qml/QtQuick/Controls.2/Material/ToolTip.qml qml/QtQuick/Controls.2/Material/Tumbler.qml
  )
  if(EXISTS "${QT_ANDROID_QT_ROOT}/jar/QtAndroid-bundled.jar")
    set(_deploymentDepends jar/QtAndroid-bundled.jar jar/QtAndroidBearer-bundled.jar jar/QtMultimedia-bundled.jar ${_deploymentDepends})
  else()
    set(_deploymentDepends jar/QtAndroid.jar jar/QtAndroidBearer.jar jar/QtAndroidExtras.jar jar/QtMultimedia.jar ${_deploymentDepends})
  endif()
  foreach(_qmlFile CheckIndicator.qml RadioIndicator.qml SwitchIndicator.qml)
    if(EXISTS "${QT_ANDROID_QT_ROOT}/qml/QtQuick/Controls.2/${_qmlFile}")
      set(_deploymentDepends ${_deploymentDepends} qml/QtQuick/Controls.2/${_qmlFile})
    endif()
  endforeach()

  include(qt-android-cmake/AddQtAndroidApk.cmake)
  set(QT_ANDROID_BUILD_TOOLS_REVISION "23.0.1")
  add_qt_android_apk(apk kid3-qml
    NAME Kid3
    PACKAGE_NAME "net.sourceforge.kid3"
    DEPENDS kid3-core kid3-gui
            musicbrainzimport discogsimport freedbimport amazonimport
            taglibmetadata kid3qml Qt${QT_VERSION_MAJOR}::Svg
            ${ANDROID_EXTRA_LIBS_DIR}/libssl_1_1.so ${ANDROID_EXTRA_LIBS_DIR}/libcrypto_1_1.so
    DEPLOYMENT_DEPENDS ${_deploymentDepends}
    PACKAGE_SOURCES ${_androidPackageDir}
    KEYSTORE ${_keystorePathAlias}
  )

  # Unfortunately, androiddeployqt performs the library stripping before copying
  # the android-extra-libs (after DEPENDS in the command above). The external
  # libraries have to be stripped by the linker before the package is built.
  set_property(TARGET musicbrainzimport APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET discogsimport APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET freedbimport APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET amazonimport APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET taglibmetadata APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET kid3qml APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET kid3-core APPEND PROPERTY LINK_FLAGS_RELEASE -s)
  set_property(TARGET kid3-gui APPEND PROPERTY LINK_FLAGS_RELEASE -s)

  add_dependencies(apk android-package musicbrainzimport discogsimport
                   freedbimport amazonimport taglibmetadata kid3qml)
else(QT_VERSION_MAJOR LESS 6)
  set(_deploymentDepends
      jar/Qt${QT_VERSION_MAJOR}Android.jar jar/Qt${QT_VERSION_MAJOR}AndroidNetwork.jar jar/Qt${QT_VERSION_MAJOR}AndroidNetworkInformationBackend.jar jar/Qt${QT_VERSION_MAJOR}AndroidMultimedia.jar
      lib/libQt${QT_VERSION_MAJOR}Core_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}Xml_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}Network_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}Gui_${ANDROID_ABI}.so
      lib/libQt${QT_VERSION_MAJOR}OpenGL_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}QmlModels_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}QuickControls2Impl_${ANDROID_ABI}.so
      lib/libQt${QT_VERSION_MAJOR}LabsFolderListModel_${ANDROID_ABI}.so lib/libQt${QT_VERSION_MAJOR}QuickLayouts_${ANDROID_ABI}.so
      plugins/networkinformation/libplugins_networkinformation_qandroidnetworkinformation_${ANDROID_ABI}.so plugins/platforms/libplugins_platforms_qtforandroid_${ANDROID_ABI}.so plugins/iconengines/libplugins_iconengines_qsvgicon_${ANDROID_ABI}.so
      plugins/tls/libplugins_tls_qopensslbackend_${ANDROID_ABI}.so
      plugins/imageformats/libplugins_imageformats_qjpeg_${ANDROID_ABI}.so
