=== src/app/qt/CMakeLists.txt ===
if(POLICY CMP0177)
  cmake_policy(SET CMP0177 NEW)
endif()

add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  kid3qtapplication.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
qt_wrap_cpp(qt_GEN_MOC_SRCS
  kid3mainwindow.h
  kid3qtapplication.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
  TARGET ${KID3_EXECUTABLE}
)
target_sources(${KID3_EXECUTABLE} PRIVATE ${qt_GEN_MOC_SRCS})

if(APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE qt.conf)
elseif(WIN32)
  if(MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif()
  # add Windows resource file with icon
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3win.rc)
endif()

if(UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT org.kde.kid3-qt.desktop
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.py
      <${CMAKE_CURRENT_SOURCE_DIR}/../org.kde.kid3.desktop >org.kde.kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../org.kde.kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS org.kde.kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications")
  add_custom_command(OUTPUT org.kde.kid3-qt.appdata.xml
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixappdata.py
      ${CMAKE_CURRENT_SOURCE_DIR}/../org.kde.kid3.appdata.xml >org.kde.kid3-qt.appdata.xml
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../org.kde.kid3.appdata.xml
  )
  add_custom_target("appdata-file" ALL DEPENDS org.kde.kid3-qt.appdata.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kid3-qt.appdata.xml
    DESTINATION "${WITH_DATAROOTDIR}/metainfo")
  if(GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cdn ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz
    )
    target_sources(${KID3_EXECUTABLE} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else()
    install(FILES ../sc-apps-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif()
  install(FILES ../128-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../64-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../48-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../32-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../16-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif(APPLE)
  install(FILES ../48-apps-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif()

qt_add_resources(qt_GEN_RCS kid3.qrc)
target_sources(${KID3_EXECUTABLE} PRIVATE
  ${qt_GEN_RCS}
)

target_link_libraries(${KID3_EXECUTABLE} kid3-gui)
if(NOT MSVC)
  target_link_libraries(${KID3_EXECUTABLE} -lstdc++)
endif()

if(APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  if(CMAKE_CXX_COMPILER MATCHES "/osxcross/")
    # When cross compiling, CPack does not know that is should be APPLE.
    install(CODE "
  set(APPLE TRUE)
  ")
  endif()
endif()

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if(LINUX_SELF_CONTAINED)
  # Change RPATH/RUNPATH of executable/library.
  macro(CHANGE_RPATH _rpath _file)
    install(CODE "
      execute_process(COMMAND chrpath -r ${_rpath} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_file}\"
                      RESULT_VARIABLE ret)
      if(NOT ret EQUAL 0)
        message(FATAL_ERROR \"CHANGE_RPATH(${_rpath} ${_file}) failed with \${ret}\")
      endif()
      ")
  endmacro()

  set_target_properties(${KID3_EXECUTABLE} PROPERTIES INSTALL_RPATH "\$ORIGIN")
endif()

if(WIN32)
  # CMAKE_INSTALL_PREFIX usually contains a drive letter which cannot be
  # prepended with some other prefix. Our build scripts set CMAKE_INSTALL_PREFIX
  # to an empty value, but this is overwritten by KDE craft.
  string(REGEX REPLACE "^[A-Za-z]:" "" destdir_prefix "${CMAKE_INSTALL_PREFIX}")
  set(destdir_prefix "\$ENV{DESTDIR}${destdir_prefix}")
else()
  set(destdir_prefix "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}")
endif()

if(APPLE OR WIN32 OR LINUX_SELF_CONTAINED)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
    "${destdir_prefix}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if(APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "${destdir_prefix}/kid3.app")
  endif()
  if(WIN32)
    set(bundle_app
      "${destdir_prefix}/${WITH_BINDIR}/kid3.exe")
  endif()
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG, WebP and SVG icon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*webp${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*.dSYM" EXCLUDE)
  install(DIRECTORY "${QT_PLUGINS_DIR}/iconengines"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*qsvgicon*${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*.dSYM" EXCLUDE)

  if(LINUX_SELF_CONTAINED)
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqjpeg${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqwebp${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/iconengines/libqsvgicon${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif()
  if(APPLE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION kid3.app/Contents/MacOS
      FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*.dSYM" EXCLUDE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/styles"
      DESTINATION ${plugin_dest_dir} OPTIONAL
      FILES_MATCHING PATTERN "libqmacstyle${CMAKE_SHARED_LIBRARY_SUFFIX}")
    if(HAVE_QTMULTIMEDIA)
      if(QT_VERSION VERSION_GREATER_EQUAL 6.4)
        install(DIRECTORY "${QT_PLUGINS_DIR}/multimedia"
          DESTINATION ${plugin_dest_dir}
          FILES_MATCHING PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
      else()
        install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
          DESTINATION ${plugin_dest_dir}
          FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}"
                         PATTERN "*.dSYM" EXCLUDE)
      endif()
    endif()
    if(QT_VERSION VERSION_GREATER_EQUAL 6.0)
      install(DIRECTORY "${QT_PLUGINS_DIR}/tls"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif()
  elseif(WIN32)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/styles"
      DESTINATION ${plugin_dest_dir} OPTIONAL
      FILES_MATCHING PATTERN "qwindowsvistastyle${CMAKE_SHARED_LIBRARY_SUFFIX}")
    if(HAVE_QTMULTIMEDIA)
      if(QT_VERSION VERSION_GREATER_EQUAL 6.4)
        install(DIRECTORY "${QT_PLUGINS_DIR}/multimedia"
          DESTINATION ${plugin_dest_dir}
          FILES_MATCHING PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
      else()
        install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
          DESTINATION ${plugin_dest_dir}
          FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
      endif()
    endif()
    if(QT_VERSION VERSION_GREATER_EQUAL 6.0)
      install(DIRECTORY "${QT_PLUGINS_DIR}/tls"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "*qopensslbackend${CMAKE_SHARED_LIBRARY_SUFFIX}"
                       PATTERN "*qschannelbackend${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif()
  elseif(LINUX_SELF_CONTAINED)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "libqwayland-*${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/wayland-graphics-integration-client"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqt-plugin-wayland-egl${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/wayland-shell-integration"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libxdg-shell${CMAKE_SHARED_LIBRARY_SUFFIX}")

    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqwayland-generic${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqwayland-egl${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/wayland-graphics-integration-client/libqt-plugin-wayland-egl${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/wayland-shell-integration/libxdg-shell${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforminputcontexts"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libcomposeplatforminputcontextplugin${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforminputcontexts/libcomposeplatforminputcontextplugin${CMAKE_SHARED_LIBRARY_SUFFIX}")
    if(QT_VERSION VERSION_LESS 6.0)
      if(HAVE_QTMULTIMEDIA)
        install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
          DESTINATION ${plugin_dest_dir}
          FILES_MATCHING PATTERN "libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
        CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/mediaservice/libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
      endif()
    else()
      install(DIRECTORY "${QT_PLUGINS_DIR}/tls"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libqopensslbackend${CMAKE_SHARED_LIBRARY_SUFFIX}")
      CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/tls/libqopensslbackend${CMAKE_SHARED_LIBRARY_SUFFIX}")
      if(QT_VERSION VERSION_GREATER_EQUAL 6.4)
        if(HAVE_QTMULTIMEDIA)
          install(DIRECTORY "${QT_PLUGINS_DIR}/multimedia"
            DESTINATION ${plugin_dest_dir}
