=== debian/changelog ===
kid3 (3.9.7-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 21 Feb 2026 15:18:35 -0800

kid3 (3.9.7-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-missing-appstream-metadata.
  * Bump Standards-Version to 4.7.2.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 11 Sep 2025 15:15:36 +0200
