=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_CMAKE_PREFIX = /usr
BASE_CMAKE_DEFS = -DKDE_INSTALL_BINDIR=$(DEB_CMAKE_PREFIX)/bin -Wno-dev -DWITH_FFMPEG=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo

%:
	dh $@ --builddirectory=kid3-build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONF_INSTALL_DIR=/etc \
		-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
		$(BASE_CMAKE_DEFS) \
		-DLIB_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/lib/kid3 \
		-DCMAKE_C_FLAGS="$(CFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS)"

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_clean:
	rm -rf $(CURDIR)/src/test/__pycache__/
	dh_clean

override_dh_compress:
	dh_compress --exclude=.docbook

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym
